/* JSGal v0.20: Copyright (c) 2004 by Andreas S. Krebs (jsgal@sberk.net) */
// below are the configuration parameter
var imgrows=3;
var imgcols=3;
var pagesinrow=20;
var thumbdir="thumbs/";
var imagedir="images/";
var thumbheight=150;
var imageheight=600;

// here starts the real coding
var imgspage=imgrows*imgcols;
var numpages=Math.ceil(images.length/imgspage);
var numpagerows=Math.ceil(numpages/pagesinrow);

function showpage(page, showall)
{
  if(page>numpages)
    page=numpages;

  if(page<1)
    page=1;

  renderpage(true, page, showall, 0);
}

function showimage(imgno)
{
  if(imgno>=images.length)
    imgno=images.length-1;

  if(imgno<0)
    imgno=0;

  renderpage(false, Math.floor(imgno/imgspage)+1, false, imgno);
}

function appendSimpleElement(parent, tag)
{
  var el=document.createElement(tag);

  if(parent)
    parent.appendChild(el);

  return el;
}

function appendText(parent, text)
{
  var el=document.createTextNode(text);

  if(parent)
    parent.appendChild(el);

  return el;
}

function appendElement(parent, tag, text)
{
  var el=appendSimpleElement(parent, tag);

  for(var i=3; (i+1)<arguments.length; i+=2) 
  {
    el.setAttribute(arguments[i], arguments[i+1]);
  }

  if(text)
    appendText(el, text);

  return el;
}

function appendNavLink(parent, title, page, showall)
{
  return appendElement(parent, "a", title, "href", "javascript:parent.showpage("+page+","+showall+");");
}

function appendImageNavLink(parent, title, imgno)
{
  return appendElement(parent, "a", title, "href", "javascript:parent.showimage("+imgno+");");
}

function appendImageLink(parent, imgno)
{
  var img=images[imgno];
  var el=appendElement(parent, "a", null, "href", "javascript:parent.showimage("+imgno+");");
  appendElement(el, "img", null, "class", "thumb", "src", thumbdir+img, "height", thumbheight);
  
  appendSimpleElement(parent, "br");
  
  el=appendElement(parent, "a", img, "href", "javascript:parent.showimage("+imgno+");", "class", "thumbfooter");
} 

function renderpage(isPage, page, showall, imgno)
{
  // now let's create the navigation - if needed
  var aEl, rowEl, colEl, navEl;

  if(numpages>1)
  {
    navEl=appendElement(null, "table", null, "class", "gallery", "width", "100%");
    rowEl=appendSimpleElement(navEl, "tr");

    if(!showall)
    {
      if(page<=1)
        appendElement(rowEl, "td", "Previous", "class", "navpage_disabled", "rowspan", numpagerows);
      else
      {
        colEl=appendElement(rowEl, "td", null, "class", "navpage", "rowspan", numpagerows);
        appendNavLink(colEl, "Previous", page-1, false);
      }
    }

    var inx=1;
    var rowend=pagesinrow;
    for(; inx<=rowend && inx<=numpages; inx++)
    {
      if(inx==page && !showall)
      {
        if(isPage)
          appendElement(rowEl, "td", page, "class", "jumppage_active");
        else
        {
          colEl=appendElement(rowEl, "td", null, "class", "jumppage_active");
          appendNavLink(colEl, inx, inx, false);
        }
      }
      else
      {
        colEl=appendElement(rowEl, "td", null, "class", "jumppage");
        appendNavLink(colEl, inx, inx, false);
      }
    }

    if(!showall)
    {
      colEl=appendElement(rowEl, "td", null, "class", "showall", "rowspan", numpagerows);
      appendNavLink(colEl, "Show All", 1, true);

      if(page>=numpages)
        appendElement(rowEl, "td", "Next", "class", "navpage_disabled", "rowspan", +numpagerows);
      else
      {
        colEl=appendElement(rowEl, "td", null, "class", "navpage", "rowspan", +numpagerows);
        appendNavLink(colEl, "Next", page+1,false);
      }
    }

    for(r=1; r<numpagerows; r++)
    {
      rowEl=appendSimpleElement(navEl, "tr");

      rowend+=pagesinrow;
      for(; inx<=rowend && inx<=numpages; inx++)
      {
        if(inx==page && !showall)
        {
          if(isPage)
            appendElement(rowEl, "td", page, "class", "jumppage_active");
          else
          {
            colEl=appendElement(rowEl, "td", null, "class", "jumppage_active");
            appendNavLink(colEl, inx, inx, false);
          }
        }
        else
        {
          colEl=appendElement(rowEl, "td", null, "class", "jumppage");
          appendNavLink(colEl, inx, inx, false);
        }
      }
    }
  }

  // now let's create the image section
  var mainEl=appendElement(null, "table", null, "class", "gallery", "width", "100%");

  if(isPage)
  {
    var numrows=imgrows;

    imgno=(page-1)*imgspage;

    if(showall)
    {
      imgno=0;
      numrows=Math.ceil(images.length/imgcols);
    }

    for(row=0; row<numrows; row++)
    {
      rowEl=appendSimpleElement(mainEl, "tr");

      for(col=0; col<imgcols; col++)
      {
        colEl=appendElement(rowEl, "td", null, "class", "thumbcell");

        if(imgno<images.length)
          appendImageLink(colEl, imgno);

        imgno++;
      }
    }
  }
  else
  {
    rowEl=appendSimpleElement(mainEl, "tr");

    if(imgno<=0)
      appendElement(rowEl, "td", "Previous", "class", "img_navpage_disabled");
    else
    {
      colEl=appendElement(rowEl, "td", null, "class", "img_navpage");
      appendImageNavLink(colEl, "Previous", imgno-1);
    }

    appendElement(rowEl, "td", images[imgno], "class", "img_jumppage_active");

    if(imgno+1>=images.length)
      appendElement(rowEl, "td", "Next", "class", "img_navpage_disabled");
    else
    {
      colEl=appendElement(rowEl, "td", null, "class", "img_navpage");
      appendImageNavLink(colEl, "Next", imgno+1);
    }

    rowEl=appendSimpleElement(mainEl, "tr");
    colEl=appendElement(rowEl, "td", null, "class", "picturecell", "colspan", 3);

    aEl=appendElement(colEl, "a", null, "href", imagedir+images[imgno], "target", "_original", "class", "picturefooter");
    appendElement(aEl, "img", null, "class", "picture", "src", imagedir+images[imgno], "height", imageheight);
    appendSimpleElement(aEl, "br");
    appendText(aEl, "Original size...");
  }

  var titleEl=appendText(null, title);

  // now let's change the page
  replaceNodes("title", titleEl);
  replaceNodes("nav", navEl);
  replaceNodes("main", mainEl);
}

function replaceNodes(elId, childEl)
{
  var el=document.getElementById(elId);

  if(el)
  {
    while(el.lastChild)
    {
      el.removeChild(el.lastChild);
    }
  }

  if(childEl)
    el.appendChild(childEl);
}

